      REAL             FUNCTION ZZMPAR(I)
C!!!! DOUBLE PRECISION FUNCTION ZZMPAR(I)

C## A R G U M E N T S:
                       INTEGER I

C## S T A T U S:
C               IGNORE LINES BEGINNING WITH  "C!!!!" .
C
C    SYSTEM  DEPENDENCE:   THE CODE IS VERY DEFINITELY MACHINE DEPENDENT
C                          FOR IT CONTAINS MACHINE PRECISION CONSTANTS
C                          FOR MANY MACHINES, AS DESCRIBED BELOW.
C
C               SINGLE/DOUBLE CONVERSION: NEEDED (SEE CONVRT).
C
C               THIS VERSION IS IN   S I N G L E   PRECISION.
C!!!!           THIS VERSION IS IN   D O U B L E   PRECISION.
C
C>RCS $HEADER: MPAR.GL,V 2.3 91/11/22 11:45:19 BUCKLEY EXP $
C>RCS $LOG:     MPAR.GL,V $
C>RCS REVISION 2.3  91/11/22  11:45:19  BUCKLEY
C>RCS FINAL SUBMISSION TO TOMS
C>RCS
C>RCS REVISION 2.2  91/06/12  14:07:08  BUCKLEY
C>RCS ADDED STARDENT
C>RCS
C>RCS REVISION 2.1  90/07/31  10:57:40  BUCKLEY
C>RCS ADDED CONSTANTS FOR IEEE FOR PC'S
C>RCS
C>RCS REVISION 2.0  90/07/06  10:39:26  BUCKLEY
C>RCS COMMON VERSION FOR TOMS AND MT
C>RCS
C>RCS REVISION 1.9.1.2  90/06/26  14:24:24  BUCKLEY
C>RCS FIXED SINGLE/DOUBLE PRECISION CONSTANTS FOR SUN4
C>RCS
C>RCS REVISION 1.9.1.1  89/07/01  11:36:48  BUCKLEY
C>RCS PREPARING SUBMITTED VERSION OF MT
C>RCS
C>RCS REVISION 1.9  89/06/30  13:30:15  BUCKLEY
C>RCS PREPARING SUBMITTED VERSION OF MT
C>RCS
C>RCS REVISION 1.3.1.1  89/05/20  13:46:28  BUCKLEY
C>RCS TEMP. TEST OF MT BEFORE SUBMITTING
C>RCS
C>RCS REVISION 1.3  89/05/18  12:13:23  BUCKLEY
C>RCS FINAL TEST OF MT BEFORE SUBMITTING
C>RCS
C>RCS REVISION 1.2  89/05/15  14:34:59  BUCKLEY
C>RCS INITIAL INSTALLATION OF MT INTO RCS FORM.
C>RCS
C>RCS REVISION 1.1  89/01/17  16:34:31  BUCKLEY
C>RCS INITIAL REVISION
C>RCS
C
C## D E S C R I P T I O N:
C
C     THIS IS A MODIFICATION OF THE TWO ROUTINES  DPMPAR AND SPMPAR
C     OBTAINED FROM  JORGE MORE.  IT HAS BEEN CHANGED ONLY TO CONFORM
C     WITH MY CONVENTIONS, AND TO ADD STATEMENTS FOR THE CDC
C     CYBERS WHICH ARE ACCEPTABLE TO FTN5 (FORTRAN '77). THE
C     OTHER CHANGES ARE:
C
C     1. THE SINGLE NAME  ZZMPAR HAS BEEN USED.  IT IS DOUBLE OR SINGLE
C        PRECISION ACCORDING TO CONVERSION BY CONVRT, JUST AS FOR ALL
C        OF MY OTHER PROGRAMS.
C
C     2. THE ROUTINES HAVE BEEN MERGED SO THAT SINGLE AND DOUBLE
C        PRECISION STATEMENTS WHICH CORRESPOND APPEAR IN PAIRS.
C
C     OTHERWISE ALL OF THE COMMENTS OF THE ORIGINAL AUTHORS APPLY.
C     THEIR ORIGINAL COMMENTS (UNALTERED) FOR THE DOUBLE PRECISION
C     VERSION FOLLOW IMMEDIATELY.
C
C     FUNCTION DPMPAR
C
C     THIS FUNCTION PROVIDES DOUBLE PRECISION MACHINE PARAMETERS
C     WHEN THE APPROPRIATE SET OF DATA STATEMENTS IS ACTIVATED (BY
C     REMOVING THE C FROM COLUMN 1) AND ALL OTHER DATA STATEMENTS ARE
C     RENDERED INACTIVE. MOST OF THE PARAMETER VALUES WERE OBTAINED
C     FROM THE CORRESPONDING BELL LABORATORIES PORT LIBRARY FUNCTION.
C
C     THE FUNCTION STATEMENT IS
C
C       DOUBLE PRECISION FUNCTION DPMPAR(I)
C
C     WHERE
C
C       I IS AN INTEGER INPUT VARIABLE SET TO 1, 2, OR 3 WHICH
C         SELECTS THE DESIRED MACHINE PARAMETER. IF THE MACHINE HAS
C         T BASE B DIGITS AND ITS SMALLEST AND LARGEST EXPONENTS ARE
C         EMIN AND EMAX, RESPECTIVELY, THEN THESE PARAMETERS ARE
C
C         DPMPAR(1)   B**(1 - T), THE MACHINE PRECISION,
C
C         DPMPAR(2)   B**(EMIN - 1), THE SMALLEST MAGNITUDE,
C
C         DPMPAR(3)   B**EMAX*(1 - B**(-T)), THE LARGEST MAGNITUDE.
C
C     ARGONNE NATIONAL LABORATORY. MINPACK PROJECT. MARCH 1980.
C     BURTON S. GARBOW, KENNETH E. HILLSTROM, JORGE J. MORE
C
C## E N T R Y   P O I N T S: THE NATURAL ENTRY ZZMPAR.
C## S U B R O U T I N E S:   NONE ARE CALLED.
C## P A R A M E T E R S:     NONE ARE DEFINED.
C
C## L O C A L   D E C L:

C         NOTE THAT THESE ARRAYS MUST HAVE DIMENSIONS 2 AND 4, RATHER
C         THAN 1 AND 2 AS ONE MIGHT EXPECT, BECAUSE OF THE PDP-11
C         DEFINITIONS.

      INTEGER MCHEPS(2)
C!!!! INTEGER MCHEPS(4)

      INTEGER MINMAG(2)
C!!!! INTEGER MINMAG(4)

      INTEGER MAXMAG(2)
C!!!! INTEGER MAXMAG(4)

      REAL             RMACH(3)
C!!!! DOUBLE PRECISION DMACH(3)

      INTEGER EMIN, EMAX, IMACH(10)

      REAL             B, BINV, BM1, ONE, W, Z
C!!!! DOUBLE PRECISION B, BINV, BM1, ONE, W, Z

C## S A V E:
                             SAVE  RMACH
C!!!!                        SAVE  DMACH

                             SAVE  IMACH

C## E Q U I V A L E N C E S:

      EQUIVALENCE (RMACH(1),MCHEPS(1))
C!!!! EQUIVALENCE (DMACH(1),MCHEPS(1))

      EQUIVALENCE (RMACH(2),MINMAG(1))
C!!!! EQUIVALENCE (DMACH(2),MINMAG(1))

      EQUIVALENCE (RMACH(3),MAXMAG(1))
C!!!! EQUIVALENCE (DMACH(3),MAXMAG(1))

C## C O M M O N:             NONE IS DEFINED.

C## D A T A:

C-----MACHINE CONSTANTS FOR THE SUN-4.

      DATA MCHEPS(1)           / X'34000000'/
C!!!! DATA MCHEPS(1),MCHEPS(2) / X'3CB00000', X'00000000' /

      DATA MINMAG(1)           / X'00800000' /
C!!!! DATA MINMAG(1),MINMAG(2) / X'00100000', X'00000000' /

      DATA MAXMAG(1)           / X'7F7FFFFF' /
C!!!! DATA MAXMAG(1),MAXMAG(2) / X'7FEFFFFF', X'FFFFFFFF'/


C## E X E C U T I O N
C## E X E C U T I O N


      ZZMPAR = RMACH(I)
C!!!! ZZMPAR = DMACH(I)


C## E X I T
90000      RETURN

C## F O R M A T S:  NONE ARE DEFINED.
C##                 E N D         OF ZZMPAR.
                    END
